/******************************************************************************

  Typing Trainer

  tpgt

  Copyright (C) 2004 Sallai Andras
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  
*******************************************************************************/



#include <ncurses.h>
#include "about.h"

void about(void)
{
    WINDOW *frame, *window;
    int height=14, width=57, ybegin=5, xbegin=10;

    initscr();
    erase();
    refresh();
    start_color();
    curs_set(0);
    
    init_pair(1, COLOR_WHITE, COLOR_BLUE);
    frame = newwin(height+2, width+2, ybegin-1, xbegin-1);
    window = newwin(height, width, ybegin, xbegin);
    
    wbkgd(frame, COLOR_PAIR(1));
    wbkgd(window, COLOR_PAIR(1));
    box(frame, 0, 0);
    
    wprintw(window, "\n"); 
    wprintw(window, "                TpgT - Typing Trainer\n\n");
    wprintw(window, "                   Version: 0.1\n\n\n\n");
//    wprintw(window, "Coders:  \n");
//    wprintw(window, "Helpers: \n");
    wprintw(window, "           Copyright (C) 2004 Sallai Andras\n"); 
    wprintw(window, "             mailto: sallaia@freemail.hu\n\n");
    wprintw(window, "                 Licence: GNU GPL\n");
    
    wrefresh(frame);
    wrefresh(window);
    
    getch();

    delwin(window);
    delwin(frame);

    clear();
    refresh();
    curs_set(1);
    endwin();

}
