/******************************************************************************

  Typing Trainer

  tpgt

  Copyright (C) 2004 Sallai Andras
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  
*******************************************************************************/


#include "checkrc.h"





void tcheck(void)
{

    FILE *ftpgtrc;
    char *tpgtfilename;
    char *home, *row, *lang;
    WINDOW *hwindow;

    initscr();
    start_color();
    init_pair(1, COLOR_WHITE, COLOR_BLUE);
    hwindow = newwin(6, 40, 8, 12);
    wbkgd(hwindow, COLOR_PAIR(1));
    box(hwindow, 0, 0);

    /* Read the option file */
    tpgtfilename = (char *) malloc(30 * sizeof(char));    
    home = (char *) malloc(30 * sizeof(char));        
    row = (char *) malloc(30 * sizeof(char));        
    lang = (char *) malloc(30 * sizeof(char));
    
    home = (char *) getenv("HOME");    
    lang = (char *) getenv("LANG");
    strcpy(tpgtfilename, home);
    strcat(tpgtfilename, "/.tpgtrc");


    if ((ftpgtrc = fopen(tpgtfilename, "w")) == NULL)
    {
	clear();
	refresh();
	endwin();
	fprintf(stderr, _("Error opening file: %s\n"), tpgtfilename);
	exit(1);
    }
    
    strcpy(row, "lang = ");
    lang[2] = '\0';    
    strcat(row, lang);
    row[strlen(row)] = '\0';

    // Write option3
    fputs(row, ftpgtrc);
    fclose(ftpgtrc);
    curs_set(0);    
    mvwaddstr(hwindow, 1, 16, _("Saved"));
    mvwaddstr(hwindow, 3, 15, _("[ Ok ]"));
    wrefresh(hwindow);
    wgetch(hwindow);

    curs_set(1);
    delwin(hwindow);
    endwin();
}

void check_tpgtrc(void)
{
    FILE *ftpgtrc;
    char *tpgtfilename;
    char *home, *row;
    WINDOW *hwindow;
    int ch;

    initscr();
    start_color();
    init_pair(1, COLOR_WHITE, COLOR_BLUE);
    hwindow = newwin(6, 70, 6, 5);
    wbkgd(hwindow, COLOR_PAIR(1));
    box(hwindow, 0, 0);

    
    
    /* Read the option file */
    tpgtfilename = (char *) malloc(30 * sizeof(char));    
    home = (char *) malloc(30 * sizeof(char));        
    row = (char *) malloc(30 * sizeof(char));        
    home = (char *) getenv("HOME");    
    strcpy(tpgtfilename, home);
    strcat(tpgtfilename, "/.tpgtrc");


    if ((ftpgtrc = fopen(tpgtfilename, "r")) == NULL)
    {
	mvwprintw(hwindow, 1, 2, _("I can't find the %s file!"), tpgtfilename);
	mvwaddstr(hwindow, 2, 2, _("Can I create the .tpgtrc file your home?"));
	mvwaddstr(hwindow, 4, 2, _("Press Y or N key!"));
	ch = wgetch(hwindow);
	if (ch == 'y' || ch == 'Y') 
	    tcheck();
	
    }


    
    
    delwin(hwindow);
    endwin();
}
