/******************************************************************************

  Typing Trainer

  tpgt

  Copyright (C) 2004 Sallai Andras
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  
*******************************************************************************/

#include <string.h>
//#include <locale.h>
#include <ncurses.h>
#include "lesson.h"
#include "convert.h"
#include "gettext.h"






void lesson(lesnum)
{

    FILE *flesson;
    FILE *ftpgtrc;
    char *filename;
    char *tpgtfilename;
    char *str;
    char *home;
    char *row;
    char *lang, *rlang;
    int llong, i, j, x, y;
    signed ch;    
    WINDOW *swindow;
    WINDOW *bwindow;
    WINDOW *hwindow;
    WINDOW *ewindow; // End Window
    signed int hiterror = 0;
    signed int rowsnum = 0;
            

    
    initscr();
    start_color();
    cbreak();
    curs_set(2);
    
//    keypad(stdscr, TRUE);
    keypad(swindow, TRUE);
//    keypad(hwindow, TRUE);
    
    noecho();
    clear();
    refresh();

    swindow = newwin(12, 60, 2, 8); //Show Window
    bwindow = newwin(14, 63, 1, 7); //BackGround Window
    hwindow = newwin(5, 63, 17, 7); //Help Window   
    
    wrefresh(swindow);
    wrefresh(bwindow);
    wrefresh(hwindow);    

    init_pair(1, COLOR_WHITE, COLOR_BLUE);
    wbkgd(swindow, COLOR_PAIR(1));
    wbkgd(bwindow, COLOR_PAIR(1));
    wbkgd(hwindow, COLOR_PAIR(1));

    box(bwindow, 0, 0);
    box(hwindow, 0, 0);    

    wrefresh(swindow);    
    wrefresh(bwindow);



    
    /* Readk the option file */
    tpgtfilename = (char *) malloc(30 * sizeof(char));    
    home = (char *) malloc(30 * sizeof(char));        
    row = (char *) malloc(30 * sizeof(char));        
    lang = (char *) malloc(30 * sizeof(char));            
    rlang = (char *) malloc(30 * sizeof(char));                
    home = (char *) getenv("HOME");    
    strcpy(tpgtfilename, home);
    strcat(tpgtfilename, "/.tpgtrc");

    if ((ftpgtrc = fopen(tpgtfilename, "r")) == NULL)
    {
	clear();
	refresh();
	endwin();
	fprintf(stderr, _("Error opening file: %s\n"), tpgtfilename);
	exit(1);
    }
    


    // Read options    
    while((strstr(row, "lang")) == NULL && (feof(ftpgtrc)) == 0)
    {
    	fgets(row, 255, ftpgtrc);
    }

    lang = strstr(row, "=");
    lang++;
    llong = strlen(lang);
    j = 0;
    for (i = 0; i < llong; i++)
    {
	 if ((isblank(lang[i])) == 0 && lang[i] != '\n') 
	 {
	    rlang[j] = lang[i];
	    j++;
	 }
    }
    rlang[j] = '\0';  // LANG in the rlang varable
    fclose(ftpgtrc);


    
    
    

    // Opening the lesson file 
    filename = (char *) malloc(30 * sizeof(char));
    str = (char *) malloc(30 * sizeof(char));
    str = (char *)  numtostr(lesnum);
        
    strcpy(filename, "lessons/"); 
    strcat(filename, rlang);
    strcat(filename, "/");
    strcat(filename, "lesson");
    strcat(filename, str);

    if ((flesson = fopen(filename, "rb")) == NULL)
    {
	clear();
	refresh();
	endwin();
	fprintf(stderr, _("Error opening file: %s\n"), filename);
	exit(1);
    }




    /* Help window */
    switch (lesnum)
    {
	case 1 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"F\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"J\" key"));
	    break;
	case 2 :
	    mvwaddstr(hwindow, 1, 2, _("Left middle finger on the \"D\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right middle finger on the \"K\" key"));
	    break;
	case 3 :
	    mvwaddstr(hwindow, 1, 2, _("Left ring finger on the \"S\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right ring finger on the \"L\" key"));
	    break;
	case 4 :
	    mvwaddstr(hwindow, 1, 2, _("Left little finger on the \"A\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \";\" key"));
	    break;
	case 5 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"G\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"H\" key"));
	    break;
	case 6 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"R\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"U\" key"));
	    break;
	case 7 :
	    mvwaddstr(hwindow, 1, 2, _("Left middle finger on the \"E\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right middle finger on the \"I\" key"));
	    break;
	case 8 :
	    mvwaddstr(hwindow, 1, 2, _("Left ring finger on the \"W\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right ring finger on the \"O\" key"));
	    break;
	case 9 :
	    mvwaddstr(hwindow, 1, 2, _("Left little finger on the \"Q\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"P\" key"));
	    break;
	case 10 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"V\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"M\" key"));
	    break;
	case 11 :
	    mvwaddstr(hwindow, 1, 2, _("Left middle finger on the \"C\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right middle finger on the \",\" key"));
	    break;
	case 12 :
	    mvwaddstr(hwindow, 1, 2, _("Left ring finger on the \"X\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right ring finger on the \".\" key"));
	    break;
	case 13 :
	    mvwaddstr(hwindow, 1, 2, _("Left little finger on the \"Z\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"/\" key"));
	    break;
	case 14 :
	    mvwaddstr(hwindow, 2, 2, _("Exercises"));
	    break;
	case 15 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"T\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"Y\" key"));
	    break;
	case 16 :
	    mvwaddstr(hwindow, 1, 2, _("Left first finger on the \"B\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right first finger on the \"N\" key"));
	    break;
	case 17 :
	    mvwaddstr(hwindow, 1, 2, _("Left little finger on the \"\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"\" key"));
	    break;
	case 18 :
	    mvwaddstr(hwindow, 1, 2, _("Right little finger on the \"\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"\" key"));
	    break;
	case 19 :
	    mvwaddstr(hwindow, 1, 2, _("Right little finger on the \"\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"\" key"));
	    break;
	case 20 :
	    mvwaddstr(hwindow, 1, 2, _("Right little finger on the \"\" key"));
	    mvwaddstr(hwindow, 2, 2, _("Right little finger on the \"\" key"));
	    break;
	case 21 :
	    mvwaddstr(hwindow, 2, 2, _("Exercises"));
	    break;
	case 22 :
	    mvwaddstr(hwindow, 2, 2, _("Exercises"));
	    break;
	case 23 :
	    mvwaddstr(hwindow, 2, 2, _("Exercises"));
	    break;
	case 24 :
	    mvwaddstr(hwindow, 2, 2, _("Exercises"));
	    break;

    }
    wrefresh(hwindow);





    /* Runing the lesson */
    while((feof(flesson)) == 0)
    {
	fgets(row, 255, flesson); 

	row[strlen(row) - 1] = '\0';

	// Number of row
	rowsnum++;

	wclear(swindow);
	wrefresh(swindow);
	mvwprintw(swindow, 2, 6, "%s", row);
        wmove(swindow, 2, 6);    
        wrefresh(swindow);
	
	/* Show errors */	
	getyx(swindow, y, x);
	mvwprintw(swindow, 10, 20, "            ");
	mvwprintw(swindow, 10, 20, _("Errors: %d"), hiterror);
	wmove(swindow, y, x);
	wrefresh(swindow);

        /* Show number of row */
	getyx(swindow, y, x);
	mvwprintw(swindow, 10, 10, "          ");
	mvwprintw(swindow, 10, 10, _("Rows: %d"), rowsnum);
	wmove(swindow, y, x);
	wrefresh(swindow);




        ch = -1; i = 0;

        while(i < strlen(row))   
        {
	    ch = wgetch(swindow);
	    if (ch == 27) break;
	    if (ch == KEY_F(10)) break;
	    
	    /* 
	       The '&' operation need for example the
	       hungarian accentuated letters! , o" and u" etc.
	    */	    
	    while(ch != (row[i] & 255))  
	    {
		    hiterror++;
		    getyx(swindow, y, x);
		    mvwprintw(swindow, 10, 20, "            ");
		    mvwprintw(swindow, 10, 20, _("Errors: %d"), hiterror);
		    wmove(swindow, y, x);
		    wrefresh(swindow);
		    getyx(swindow, y, x);
		    beep();
		    getyx(swindow, y, x);
		    mvwprintw(swindow, 8, 25, " %c", ch);
		    wmove(swindow, y,x);
		    wrefresh(swindow);
		    if (ch == 27) break;
		    if (ch == KEY_F(10)) break;
		    ch = wgetch(swindow);
		    if (ch == 27) break;
		    if (ch == KEY_F(10)) break;
	    }/* while */
	    getyx(swindow, y, x); 
	    wmove(swindow, y + 2, x);	    	    
	    waddch(swindow, ch);
	    wmove(swindow, y, x);
	    wrefresh(swindow);

	    getyx(swindow, y, x);
	    wmove(swindow, y, x + 1);
	    
	    getyx(swindow, y, x);
	    mvwprintw(swindow, 8, 25, " %c", ch);
	    wmove(swindow, y,x);

	    ch = -1;
	    i++;	    
	}/* while */
	if (ch == 27 || ch == KEY_F(10)) break;
	ch = wgetch(swindow);
	if (ch == 27 || ch == KEY_F(10)) break;	
	while( ch != 10)  //Enter pressed
	{
	    beep(); // This isn't the Enter key
	    if (ch == 27 || ch == KEY_F(10)) break;	    
	    ch = wgetch(swindow);
	    hiterror++;
	}/* while */
	if (ch == 27 || ch == KEY_F(10)) break;
    }/* while */
    
    fclose(flesson);

//    free(filename); free(home); free(str);    

    delwin(swindow);
    delwin(bwindow);    
    delwin(hwindow);


    /***  Result Window ***/
    curs_set(0);
    ewindow = newwin(10, 50, 7, 14); //End Window   
    keypad(ewindow, TRUE);
    wrefresh(ewindow);
    wbkgd(ewindow, COLOR_PAIR(1));
    
    box(ewindow, 0, 0);    
    wrefresh(ewindow);
    mvwaddstr(ewindow, 2, 20, _("Results"));
    mvwprintw(ewindow, 5, 5, _("Errors: %d"), hiterror);
    mvwprintw(ewindow, 7, 22, _("Ok"));
    wrefresh(ewindow);    
    wgetch(ewindow);
    curs_set(1);
    delwin(ewindow);
    endwin();
}










void beginer_lesson(int lesnum)
{
    initscr();
    clear();
    refresh();

    lesson(lesnum);
    
    endwin();
}

void intermediate_lesson(int lesnum)
{
    initscr();
    clear();
    refresh();

    lesson(lesnum);    
    
    endwin();
}
