/******************************************************************************

  Typing Trainer

  tpgt

  Copyright (C) 2004 Sallai Andras
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  
*******************************************************************************/

#include "menus.h"
#include "options.h"
#include "gettext.h"

void lang_out(char *lang)
{
    FILE *ftpgtrc;
    char *tpgtfilename;
    char *home, *row;
    WINDOW *hwindow;

    initscr();
    start_color();
    init_pair(1, COLOR_WHITE, COLOR_BLUE);
    hwindow = newwin(6, 40, 8, 12);
    wbkgd(hwindow, COLOR_PAIR(1));
    box(hwindow, 0, 0);


    /* Read the option file */
    tpgtfilename = (char *) malloc(30 * sizeof(char));    
    home = (char *) malloc(30 * sizeof(char));        
    row = (char *) malloc(30 * sizeof(char));        
    home = (char *) getenv("HOME");    
    strcpy(tpgtfilename, home);
    strcat(tpgtfilename, "/.tpgtrc");


    if ((ftpgtrc = fopen(tpgtfilename, "w")) == NULL)
    {
	clear();
	refresh();
	endwin();
	fprintf(stderr, _("Error opening file: %s\n"), tpgtfilename);
	exit(1);
    }
    
    strcpy(row, "lang = ");
    strcat(row, lang);
    row[strlen(row)] = '\0';

    // Write option3
    fputs(row, ftpgtrc);
    fclose(ftpgtrc);
    curs_set(0);    
    mvwaddstr(hwindow, 1, 16, _("Saved"));
    mvwaddstr(hwindow, 3, 15, _("[ Ok ]"));
    wrefresh(hwindow);
    wgetch(hwindow);

    curs_set(1);
    delwin(hwindow);
    endwin();
}




void language(void)
{
    int elected;
    struct mcolor_s bcolor = {FEHER, KEK, FEKETE, FEHER};
    int x = 25;
    int y = 8;
    char *menuitem[3];
    int i, begin, vege = 0, menunum = 2;

    
    initscr();
    
    for (i = 0; i < menunum; i++)
	menuitem[i] = (char *) calloc(40, sizeof(char));

    strcpy(menuitem[0], _(" English "));
    strcpy(menuitem[1], _(" Hungarian "));
    menuitem[2] = NULL;

    

    while(!vege)
    {
        clear();
	refresh();
    
	elected = menu_s(menuitem, x, y, begin, 1, bcolor, FEHER);

	begin = elected;

	switch (elected)
	{
	    case 1 : 
		    lang_out("en");
		    vege = 1;
		   break;
	    case 2 :
		     lang_out("hu");
		     vege = 1;
		   break;
	    default : vege = 1;
	} /* switch */

    }/* while(1) */
    endwin();


}

void envir(void)
{
    initscr();
    clear();
    refresh();
    addstr("Envir shadow function\n");
    addstr("Not implemented yet\n");
    addstr("Press any key to continue...\n");
    getch();
    endwin();

}





void options(void)
{
    int elected;
    struct mcolor_s bcolor = {FEHER, KEK, FEKETE, FEHER};
    int x = 25;
    int y = 8;
    char *menuitem[4];
    int i, begin, vege = 0, menunum = 3;
    
    for (i = 0; i < menunum; i++)
	menuitem[i] = (char *) calloc(40, sizeof(char));

    strcpy(menuitem[0], _(" Language "));
    strcpy(menuitem[1], _(" Environment "));
    strcpy(menuitem[2], _(" Main menu "));
    menuitem[3] = NULL;

    initscr();

    while(!vege)
    {
        clear();
	refresh();
    
	elected = menu_s(menuitem, x, y, begin, 1, bcolor, FEHER);

	begin = elected;

	switch (elected)
	{
	    case 1 : language();
		   break;
	    case 2 : envir();
		   break;
	    default : vege = 1;
	} /* switch */

    }/* while(1) */
    endwin();
}


